// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package freeje_admin

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// CurrencyClient is the client API for Currency service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type CurrencyClient interface {
	// Получить список всех валют
	List(ctx context.Context, in *CurrencyCode, opts ...grpc.CallOption) (Currency_ListClient, error)
	// Добавить валюту или обновить ее описание
	Update(ctx context.Context, in *CurrencyCode, opts ...grpc.CallOption) (*CurrencyCode, error)
	// Удалить валюту
	Delete(ctx context.Context, in *CurrencyCode, opts ...grpc.CallOption) (*CurrencyCode, error)
	// Получить список всех конвертаций по валюте
	ListRates(ctx context.Context, in *CurrencyCode, opts ...grpc.CallOption) (Currency_ListRatesClient, error)
	// Получить значение конкретной конвертации
	GetRate(ctx context.Context, in *CurrencyRate, opts ...grpc.CallOption) (*CurrencyRate, error)
	// Добавить или обновить курс
	UpdateRate(ctx context.Context, in *CurrencyRate, opts ...grpc.CallOption) (*CurrencyRate, error)
	// Удвлить значение  конвертации
	DeleteRate(ctx context.Context, in *CurrencyRate, opts ...grpc.CallOption) (*CurrencyRate, error)
}

type currencyClient struct {
	cc grpc.ClientConnInterface
}

func NewCurrencyClient(cc grpc.ClientConnInterface) CurrencyClient {
	return &currencyClient{cc}
}

func (c *currencyClient) List(ctx context.Context, in *CurrencyCode, opts ...grpc.CallOption) (Currency_ListClient, error) {
	stream, err := c.cc.NewStream(ctx, &Currency_ServiceDesc.Streams[0], "/com.freeje.api.admin.Currency/List", opts...)
	if err != nil {
		return nil, err
	}
	x := &currencyListClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Currency_ListClient interface {
	Recv() (*CurrencyCode, error)
	grpc.ClientStream
}

type currencyListClient struct {
	grpc.ClientStream
}

func (x *currencyListClient) Recv() (*CurrencyCode, error) {
	m := new(CurrencyCode)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *currencyClient) Update(ctx context.Context, in *CurrencyCode, opts ...grpc.CallOption) (*CurrencyCode, error) {
	out := new(CurrencyCode)
	err := c.cc.Invoke(ctx, "/com.freeje.api.admin.Currency/Update", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *currencyClient) Delete(ctx context.Context, in *CurrencyCode, opts ...grpc.CallOption) (*CurrencyCode, error) {
	out := new(CurrencyCode)
	err := c.cc.Invoke(ctx, "/com.freeje.api.admin.Currency/Delete", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *currencyClient) ListRates(ctx context.Context, in *CurrencyCode, opts ...grpc.CallOption) (Currency_ListRatesClient, error) {
	stream, err := c.cc.NewStream(ctx, &Currency_ServiceDesc.Streams[1], "/com.freeje.api.admin.Currency/ListRates", opts...)
	if err != nil {
		return nil, err
	}
	x := &currencyListRatesClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Currency_ListRatesClient interface {
	Recv() (*CurrencyRate, error)
	grpc.ClientStream
}

type currencyListRatesClient struct {
	grpc.ClientStream
}

func (x *currencyListRatesClient) Recv() (*CurrencyRate, error) {
	m := new(CurrencyRate)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *currencyClient) GetRate(ctx context.Context, in *CurrencyRate, opts ...grpc.CallOption) (*CurrencyRate, error) {
	out := new(CurrencyRate)
	err := c.cc.Invoke(ctx, "/com.freeje.api.admin.Currency/GetRate", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *currencyClient) UpdateRate(ctx context.Context, in *CurrencyRate, opts ...grpc.CallOption) (*CurrencyRate, error) {
	out := new(CurrencyRate)
	err := c.cc.Invoke(ctx, "/com.freeje.api.admin.Currency/UpdateRate", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *currencyClient) DeleteRate(ctx context.Context, in *CurrencyRate, opts ...grpc.CallOption) (*CurrencyRate, error) {
	out := new(CurrencyRate)
	err := c.cc.Invoke(ctx, "/com.freeje.api.admin.Currency/DeleteRate", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// CurrencyServer is the server API for Currency service.
// All implementations should embed UnimplementedCurrencyServer
// for forward compatibility
type CurrencyServer interface {
	// Получить список всех валют
	List(*CurrencyCode, Currency_ListServer) error
	// Добавить валюту или обновить ее описание
	Update(context.Context, *CurrencyCode) (*CurrencyCode, error)
	// Удалить валюту
	Delete(context.Context, *CurrencyCode) (*CurrencyCode, error)
	// Получить список всех конвертаций по валюте
	ListRates(*CurrencyCode, Currency_ListRatesServer) error
	// Получить значение конкретной конвертации
	GetRate(context.Context, *CurrencyRate) (*CurrencyRate, error)
	// Добавить или обновить курс
	UpdateRate(context.Context, *CurrencyRate) (*CurrencyRate, error)
	// Удвлить значение  конвертации
	DeleteRate(context.Context, *CurrencyRate) (*CurrencyRate, error)
}

// UnimplementedCurrencyServer should be embedded to have forward compatible implementations.
type UnimplementedCurrencyServer struct {
}

func (UnimplementedCurrencyServer) List(*CurrencyCode, Currency_ListServer) error {
	return status.Errorf(codes.Unimplemented, "method List not implemented")
}
func (UnimplementedCurrencyServer) Update(context.Context, *CurrencyCode) (*CurrencyCode, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Update not implemented")
}
func (UnimplementedCurrencyServer) Delete(context.Context, *CurrencyCode) (*CurrencyCode, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Delete not implemented")
}
func (UnimplementedCurrencyServer) ListRates(*CurrencyCode, Currency_ListRatesServer) error {
	return status.Errorf(codes.Unimplemented, "method ListRates not implemented")
}
func (UnimplementedCurrencyServer) GetRate(context.Context, *CurrencyRate) (*CurrencyRate, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetRate not implemented")
}
func (UnimplementedCurrencyServer) UpdateRate(context.Context, *CurrencyRate) (*CurrencyRate, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateRate not implemented")
}
func (UnimplementedCurrencyServer) DeleteRate(context.Context, *CurrencyRate) (*CurrencyRate, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeleteRate not implemented")
}

// UnsafeCurrencyServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to CurrencyServer will
// result in compilation errors.
type UnsafeCurrencyServer interface {
	mustEmbedUnimplementedCurrencyServer()
}

func RegisterCurrencyServer(s grpc.ServiceRegistrar, srv CurrencyServer) {
	s.RegisterService(&Currency_ServiceDesc, srv)
}

func _Currency_List_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(CurrencyCode)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(CurrencyServer).List(m, &currencyListServer{stream})
}

type Currency_ListServer interface {
	Send(*CurrencyCode) error
	grpc.ServerStream
}

type currencyListServer struct {
	grpc.ServerStream
}

func (x *currencyListServer) Send(m *CurrencyCode) error {
	return x.ServerStream.SendMsg(m)
}

func _Currency_Update_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CurrencyCode)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(CurrencyServer).Update(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.admin.Currency/Update",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(CurrencyServer).Update(ctx, req.(*CurrencyCode))
	}
	return interceptor(ctx, in, info, handler)
}

func _Currency_Delete_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CurrencyCode)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(CurrencyServer).Delete(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.admin.Currency/Delete",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(CurrencyServer).Delete(ctx, req.(*CurrencyCode))
	}
	return interceptor(ctx, in, info, handler)
}

func _Currency_ListRates_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(CurrencyCode)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(CurrencyServer).ListRates(m, &currencyListRatesServer{stream})
}

type Currency_ListRatesServer interface {
	Send(*CurrencyRate) error
	grpc.ServerStream
}

type currencyListRatesServer struct {
	grpc.ServerStream
}

func (x *currencyListRatesServer) Send(m *CurrencyRate) error {
	return x.ServerStream.SendMsg(m)
}

func _Currency_GetRate_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CurrencyRate)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(CurrencyServer).GetRate(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.admin.Currency/GetRate",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(CurrencyServer).GetRate(ctx, req.(*CurrencyRate))
	}
	return interceptor(ctx, in, info, handler)
}

func _Currency_UpdateRate_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CurrencyRate)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(CurrencyServer).UpdateRate(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.admin.Currency/UpdateRate",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(CurrencyServer).UpdateRate(ctx, req.(*CurrencyRate))
	}
	return interceptor(ctx, in, info, handler)
}

func _Currency_DeleteRate_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CurrencyRate)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(CurrencyServer).DeleteRate(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.admin.Currency/DeleteRate",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(CurrencyServer).DeleteRate(ctx, req.(*CurrencyRate))
	}
	return interceptor(ctx, in, info, handler)
}

// Currency_ServiceDesc is the grpc.ServiceDesc for Currency service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Currency_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "com.freeje.api.admin.Currency",
	HandlerType: (*CurrencyServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Update",
			Handler:    _Currency_Update_Handler,
		},
		{
			MethodName: "Delete",
			Handler:    _Currency_Delete_Handler,
		},
		{
			MethodName: "GetRate",
			Handler:    _Currency_GetRate_Handler,
		},
		{
			MethodName: "UpdateRate",
			Handler:    _Currency_UpdateRate_Handler,
		},
		{
			MethodName: "DeleteRate",
			Handler:    _Currency_DeleteRate_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "List",
			Handler:       _Currency_List_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "ListRates",
			Handler:       _Currency_ListRates_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "admin/currency.proto",
}
